/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __AES_H_
#define __AES_H_

#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "common.h"
#include "cgc.h"

#define ENCRYPT_MODE 0
#define DECRYPT_MODE 1

#define AES_ECB_MODE 0
#define AES_CBC_MODE 1
#define AES_CTR_MODE 2

#define KEY_LENGTH_128 0
#define KEY_LENGTH_256 1


/***********************************************************************************************************************
Typedef definitions
***********************************************************************************************************************/

/*AES define*/
typedef struct {
	uint8_t encrypt_mode;
	uint8_t run_mode;
	uint8_t key_length;
	uint32_t* pIVdata;
	uint32_t* pKeydata;
}AES_InitTypeDef;

/***********************************************************************************************************************
Global functions
***********************************************************************************************************************/
//=================================================================================================================
void AES_Init(AES_InitTypeDef* pAESInit);
void AES_Encrypt(AES_InitTypeDef* pAESInit,uint8_t* pInputdata,uint8_t* pOutputdata);
void AES_Decrypt(AES_InitTypeDef* pAESInit,uint8_t* pInputdata,uint8_t* pOutputdata);


uint8_t AES_K0Writable_Status(void);
uint8_t AES_K1Writable_Status(void);
uint8_t AES_IVWritable_Status(void);
uint8_t AES_CREGWritable_Status(void);
uint8_t AES_DataWritable_Status(void);
uint8_t AES_DataReadable_Status(void);
void AES_Start(void);
void AES_Reset(void);


#endif

