#ifndef __DAC_H__
#define __DAC_H__
#include <stdio.h>
#include <stdint.h>
#include "common.h"


typedef enum
{
	DAC0	  = 0,	
	DAC1	  = 1 ,		

} DAC_TypeDef;

/********DAC output**************************/
#define DAC_OutToPort 0
#define DAC_OutToAcmp 1

/********DAC mode**************************/
#define DAC_Normal 		0
#define DAC_RealOut 	1

/********DAC output Pin**************************/
//GROUP_AF_ANO0: PB02
//GROUP_AF_ANO1: PB03

/**
  * @brief  Start the specified DAC channel .
  * @param  DACx:DAC0, DAC1
  * @retval None
  */
void DAC_Start(DAC_TypeDef DACx);

/**
  * @brief  Stop the specified DAC channel .
* @param  DACx:DAC0, DAC1
  * @retval None
  */
void DAC_Stop(DAC_TypeDef DACx);

/**
  * @brief  Select DAC output to AOx port or ACMP .
  * @param  DACx:DAC0, DAC1
  * @param  OutMod:
  *              DAC_OutToPort: DAC out to AOx
  *              DAC_OutToAcmp: DAC out to ACMP Negative
  * @retval None
  */
void DAC_SelectOut(DAC_TypeDef DACx,uint8_t OutMod);

/**
  * @brief  Select DAC output mode .
  * @param  DACx:DAC0, DAC1
  * @param  Mod:
  *              DAC_Normal: DAC normal run
  *              DAC_RealOut: DAC real output
  * @retval None
  */
void DAC_Mode(DAC_TypeDef DACx,uint8_t Mod);
	
#endif

