#ifndef __DMA_H__
#define __DMA_H__
#include <stdint.h>
#include "common.h"

typedef enum {
   ELC_EVENT_LINK_DMA0 		=  0U,  /* Χ¼17ELSR17 */
   ELC_EVENT_LINK_DMA1 		=  1U,  /* Χ¼18ELSR18 */
   ELC_EVENT_LINK_DMA2 		=  2U,  /* Χ¼19ELSR19 */
   ELC_EVENT_LINK_DMA3 		=  3U,  /* Χ¼20ELSR20 */
	 ELC_EVENT_LINK_DMA4 	 	=  4U,  /* Χ¼21ELSR21 */
   ELC_EVENT_LINK_DMA5   	=  5U,  /* Χ¼22ELSR22 */
	 ELC_EVENT_LINK_DMA6    =  6U,  /* Χ¼23ELSR23 */
   ELC_EVENT_LINK_DMA7    =  7U,  /* Χ¼24ELSR24 */
	 ELC_EVENT_LINK_DMA8    =  8U,  /* Χ¼25ELSR25 */
   ELC_EVENT_LINK_DMA9    =  9U,  /* Χ¼26ELSR26 */
   ELC_EVENT_LINK_DMA10   = 10U,  /* Χ¼27ELSR27 */  
   ELC_EVENT_LINK_DMA11   = 11U,  /* Χ¼28ELSR28 */ 
	 ELC_EVENT_LINK_DMA12   = 12U,  /* Χ¼29ELSR29 */
   ELC_EVENT_LINK_DMA13   = 13U,  /* Χ¼30ELSR30 */
   ELC_EVENT_LINK_DMA14  	= 14U,  /* Χ¼31ELSR31 */
   ELC_EVENT_LINK_DMA15  	= 15U,  /* Χ¼32ELSR32 */ 

}DMA_VECTOR_t;

typedef enum {
   DMA_VECTOR_INTP0 	=  0U,  /* ⲿжINTP0 */
   DMA_VECTOR_INTP1 	=  1U,  /* ⲿжINTP1 */
   DMA_VECTOR_INTP2 	=  2U,  /* ⲿжINTP2 */
   DMA_VECTOR_INTP3 	=  3U,  /* ⲿжINTP3 */
	 DMA_VECTOR_KEY 	  =  4U,  /* ж */
   DMA_VECTOR_ADC   	=  5U,  /* A/D ת */

	 DMA_VECTOR_ST0       =  6U,  /* UART0ʹͽ/SPI00ͽ߻/IIC00ͽ */
   DMA_VECTOR_SPI00     =  6U,  /* UART0ʹͽ/SPI00ͽ߻/IIC00ͽ */
   DMA_VECTOR_IIC00     =  6U,  /* UART0ʹͽ/SPI00ͽ߻/IIC00ͽ */
   DMA_VECTOR_SR0       =  7U,  /* UART0մͽ/SPI01ͽ߻/IIC01ͽ */
   DMA_VECTOR_SPI01     =  7U,  /* UART0մͽ/SPI01ͽ߻/IIC01ͽ */
   DMA_VECTOR_IIC01     =  7U,  /* UART0մͽ/SPI01ͽ߻/IIC01ͽ */

	 DMA_VECTOR_ST1       = 8U,  /* UART1ʹͽ/SPI10ͽ߻/IIC10ͽ */
   DMA_VECTOR_SPI10     = 8U,  /* UART1ʹͽ/SPI10ͽ߻/IIC10ͽ */
   DMA_VECTOR_IIC10     = 8U,  /* UART1ʹͽ/SPI10ͽ߻/IIC10ͽ */
   DMA_VECTOR_SR1       = 9U,  /* UART1մͽ/SPI11ͽ߻/IIC11ͽ */
   DMA_VECTOR_SPI11     = 9U,  /* UART1մͽ/SPI11ͽ߻/IIC11ͽ */
   DMA_VECTOR_IIC11     = 9U,  /* UART1մͽ/SPI11ͽ߻/IIC11ͽ */

   DMA_VECTOR_ST2       = 10U,  /* UART2ʹͽ/SPI20ͽ߻/IIC20ͽ */
   DMA_VECTOR_SPI20     = 10U,  /* UART2ʹͽ/SPI20ͽ߻/IIC20ͽ */
   DMA_VECTOR_IIC20     = 10U,  /* UART2ʹͽ/SPI20ͽ߻/IIC20ͽ */
  
   DMA_VECTOR_SR2       = 11U,  /* UART2մͽ/SPI21ͽ߻/IIC21ͽ */
   DMA_VECTOR_SPI21     = 11U,  /* UART2մͽ/SPI21ͽ߻/IIC21ͽ */
   DMA_VECTOR_IIC21     = 11U,  /* UART2մͽ/SPI21ͽ߻/IIC21ͽ */
	 
	 DMA_VECTOR_IICA      = 12U,  /* IICAͨŽ */
   DMA_VECTOR_SPI       = 13U,  /* SPIͽ */
   DMA_VECTOR_TM80_CH0  = 14U,  /* ʱеԪ0ͨ0ļ߲ */
   DMA_VECTOR_TM80_CH1  = 15U,  /* ʱеԪ0ͨ1ļ߲ */ 
   DMA_VECTOR_TM80_CH2  = 16U,  /* ʱеԪ0ͨ2ļ߲ */
   DMA_VECTOR_TM80_CH3  = 17U,  /* ʱеԪ0ͨ3ļ߲ */
	 DMA_VECTOR_TMA       = 18U,  /* ʱеԪ0ͨ3ļ߲ */
	 DMA_VECTOR_RTC       = 19U,  /* RTCź/һ¼ */
	 
   DMA_VECTOR_IT        = 20U,  /* ʱж */
   DMA_VECTOR_CMP0      = 21U,  /* Ƚ0 */
   DMA_VECTOR_CMP1      = 22U,  /* Ƚ1 */
   DMA_VECTOR_FLASH     = 23U,  /* Flash/д */
}DMA_VECTOR_t0;

#define DMA_SrcInc_Enable      			((uint8_t)0x01)
#define DMA_SrcInc_Disable     			((uint8_t)0x00)

#define DMA_DstInc_Enable      			((uint8_t)0x01)
#define DMA_DstInc_Disable     			((uint8_t)0x00)

#define DMA_DataSize_Byte           	((uint16_t)0x0000) 
#define DMA_DataSize_HalfWord       	((uint16_t)0x0040) 
#define DMA_DataSize_Word           	((uint16_t)0x0080)

typedef enum
{
	DMA_Mode_Normal,
	DMA_Mode_Repeat	
}DMA_Mode_t;


#define DMA_RepeatAreaAddr_Src          ((uint8_t)0x02) 
#define DMA_RepeatAreaAddr_Dst 			    ((uint8_t)0x00)

#define DMA_RepeatInt_Enable            ((uint8_t)0x01) 
#define DMA_RepeatInt_Disable           ((uint8_t)0x00)


#define DMA_ChainTrans_None             ((uint8_t)0x00) 
#define DMA_ChainTrans_Head             ((uint8_t)0x01) 
#define DMA_ChainTrans_Node             ((uint8_t)0x02) 
#define DMA_ChainTrans_Tail             ((uint8_t)0x03) 
typedef struct
{
	DMA_VECTOR_t DMA_Vector;            /*!< Specifies the Vector used for the dma start source . 
	                                    This parameter can be a value of @ref DMA_VECTOR_t */
											
	uint16_t DMA_CtrlId;			/*!< Specifies the control data area id for the dma */
										  											
	uint32_t DMA_SrcAddr; /*!< Specifies the peripheral source base address for DMA */

	uint32_t DMA_DstAddr;    /*!< Specifies the peripheral destion base address for DMA*/
	                                    

	uint16_t DMA_BufferSize;         /*!< Specifies the buffer size, in data unit, of the specified Stream. */ 
	                                    
//	uint16_t DMA_BlockSize;         /*!< Specifies the DMA block size when transmittion,it can be 0x0000~0xFFFF. */ 
	                                    
	uint16_t DMA_SrcInc;      /*!< Specifies whether the Peripheral source address register should be incremented or not.
	                                   This parameter can be a value of @ref DMA_peripheral_incremented_mode */

	uint16_t DMA_DstInc;          /*!< Specifies whether the destnation address register should be incremented or not.
	                                    This parameter can be a value of @ref DMA_memory_incremented_mode */

	uint16_t DMA_DataSize;    /*!< Specifies the Peripheral data width.
	                                    This parameter can be a value of @ref DMA_peripheral_data_size */

	uint8_t DMA_Mode;               /*!< Specifies the operation mode of the DMA.
	                                    This parameter can be a value of @ref DMA_circular_normal_mode
	                                    @note The circular buffer mode cannot be used if the memory-to-memory
	                                          data transfer is configured on the selected Stream */


	uint8_t DMA_RepeatAreaAddr;          /*!< Specifies if the source or destnation address will be used for repeat area in DMA_Mode_Repeat
	                                    This parameter can be a value of @ref DMA_RepeatAddr
	                                    @note The DMA_RepeatAddr cannot be configured in Normal mode */
	                                            
	uint8_t DMA_RepeatInt;		  /*!< Specifies if interrupt is occured when transimission is finished in repeat area
										  This parameter can be a value of @ref DMA_RepeatInt
										  @note The DMA_RepeatInt is not effective in Normal mode */

	uint8_t DMA_ChainTrans;		  /*!< multi-control data transimission is triggered by one vector 
										  This parameter can be a value of @ref DMA_ChainTranStart*/
										 
}DMA_InitTypeDef;

void DMA_Start(DMA_VECTOR_t vect_num);
void DMA_Init(DMA_InitTypeDef * DMA_InitStruct);
void DMA_Stop(DMA_VECTOR_t vect_num);
void DMA_Trigger(DMA_VECTOR_t vect_num);

#endif
