#ifndef __EPWM__H_
#define __EPWM__H_
#include "common.h"

#define PWM_WPKey   (0XA5<<GPT0_GTWP00_PRKEY_Pos)


//typedef enum
//{
//	GPT0 = 0,			//GPT00,GPT01,GPT02,GPT03
//	GPT1 = 1,     //GPT10,GPT11,GPT12,GPT13,GPT14,GPT15,GPT16,GPT17
//}GPTSelect_t;

/**************PWM timer start source******************************/ 
typedef enum
{ 
	PWMSrc_GTETRGA_R  = 0, 	/*!< PWM timer trigger source: rising of Triger A */
	PWMSrc_GTETRGA_F	= 1, 	/*!< PWM timer trigger source: falling of Triger A */
	PWMSrc_GTETRGB_R  = 2, 	/*!< PWM timer trigger source: rising of Triger B */
	PWMSrc_GTETRGB_F	= 3, 	/*!< PWM timer trigger source: falling of Triger B */
	PWMSrc_GTETRGC_R  = 4, 	/*!< PWM timer trigger source: rising of Triger C */
	PWMSrc_GTETRGC_F	= 5, 	/*!< PWM timer trigger source: falling of Triger C */
	PWMSrc_GTETRGD_R  = 6, 	/*!< PWM timer trigger source: rising of Triger D */
	PWMSrc_GTETRGD_F	= 7, 	/*!< PWM timer trigger source: falling of Triger D */
	PWMSrc_GTIO_ARBL	= 8, 	/*!< PWM timer trigger source: GTIOCA is rising while GTIOCB low*/
	PWMSrc_GTIO_ARBH	= 9, 	/*!< PWM timer trigger source: GTIOCA is rising while GTIOCB high*/
	PWMSrc_GTIO_AFBL	= 10, 	/*!< PWM timer trigger source: GTIOCA is falling while GTIOCB low*/
	PWMSrc_GTIO_AFBH	= 11, 	/*!< PWM timer trigger source: GTIOCA is falling while GTIOCB high*/
	PWMSrc_GTIO_BRAL	= 12, 	/*!< PWM timer trigger source: GTIOCB is rising while GTIOCA low*/
	PWMSrc_GTIO_BRAH	= 13, 	/*!< PWM timer trigger source: GTIOCB is rising while GTIOCA high*/
	PWMSrc_GTIO_BFAL	= 14, 	/*!< PWM timer trigger source: GTIOCB is falling while GTIOCA low*/
	PWMSrc_GTIO_BFAH	= 15, 	/*!< PWM timer trigger source: GTIOCB is falling while GTIOCA high*/	
	PWMSrc_ELCA				= 16, 	/*!< PWM timer trigger source: ELCA*/	
	PWMSrc_ELCB				= 17, 	/*!< PWM timer trigger source: ELCB*/	
	PWMSrc_ELCC				= 18, 	/*!< PWM timer trigger source: ELCC*/	
	PWMSrc_ELCD				= 19, 	/*!< PWM timer trigger source: ELCD*/	
	PWMSrc_Soft_GTSTR	= 31, 	/*!< PWM timer trigger source: soft register GTSTR(PWM_SoftStart())*/	
	
}PWMSrc_TypeDef;

/**************PWM mode select******************************/ 
typedef enum 
{
     PWM_SawtoothWave     	=	0 ,     //ݲ PWM ģʽ
     PWM_SToothOneTimeWave  = 1 ,     //ݲһģʽ
     PWM_TriWave_Mode1			=	4 ,     //ȴ 32 λ
     PWM_TriWave_Mode2			=	5 ,     //崦 32 λ
     PWM_TriWave_Mode3			=	6 ,     //ȴ 64 λ
}GTIOMod_FunState;  


/**************PWM mode select******************************/ 
typedef enum 
{
     PWM_Div_1     =	0 ,      //1 Ƶ
     PWM_Div_4     =  1 ,      //4 Ƶ
     PWM_Div_16    =	2 ,      //16 Ƶ
     PWM_Div_64    =	3 ,      //64 Ƶ
     PWM_Div_256   =	4 ,      //256 Ƶ
     PWM_Div_1024  = 	5 ,      //1024 Ƶ
}GTIODiv_FunState;  


/**************PWM timer direction******************************/ 
typedef enum 
{
    PWM_TimerDec       = 		 	0,  //ݼ
    PWM_TimerInc       = 		 	1,  //
}GTIODir_FunState;

/**************PWM GTIOCA output duty******************************/ 
typedef enum 
{
    PWM_GTIOCx_Duty0      =	2 , //0% duty
    PWM_GTIOCx_Duty100    =   3 , //100% duty
}GTIOForceDuty_FunState;  

/**************PWM GTIOCA/GTIOCB IO Function******************************/ 
typedef enum 
{
     PWM_GTIOCx_LowCEndKpCompareMatch        =	0  ,     //ʼͣѭȽƥ
     PWM_GTIOCx_LowCEndCompareMatch        	 = 1   ,     //ʼͣѭıȽƥ
     PWM_GTIOCx_LowCEndHighCompareMatch      =  2  ,     //ʼͣѭ,ڱȽƥ
     PWM_GTIOCx_LowCEndSwCompareMatch        =  3  ,     //ʼͣѭ,лڱȽƥ
     PWM_GTIOCx_Low0OutKpCompareMatch        =	4  ,     //ʼͣڽ0Ƚƥ
     PWM_GTIOCx_Low0OutCompareMatch        	 = 5   ,     //ʼͣڽ0Ƚƥ
     PWM_GTIOCx_Low0OutdHighCompareMatch     =  6  ,     //ʼͣڽ0ڱȽƥ
     PWM_GTIOCx_Low0OutSwCompareMatch        =  7  ,     //ʼͣڽ0лڱȽƥ
     PWM_GTIOCx_Low1OutKpCompareMatch        =	8  ,     //ʼͣڽ1Ƚƥ
     PWM_GTIOCx_Low1OutCompareMatch        	 = 9   ,     //ʼͣڽ1Ƚƥ
     PWM_GTIOCx_Low1OutdHighCompareMatch     =  10 ,      //ʼͣڽ1ڱȽƥ
     PWM_GTIOCx_Low1OutSwCompareMatch        =  11 ,      //ʼͣڽ1лڱȽƥ
     PWM_GTIOCx_LowSwOutKpCompareMatch       = 	12 ,      //ʼͣڽлȽƥ
     PWM_GTIOCx_LowSwOutCompareMatch         =  13 ,      //ʼͣڽлȽƥ
     PWM_GTIOCx_LowSwOutdHighCompareMatch    =  14 ,      //ʼͣڽлڱȽƥ
     PWM_GTIOCx_LowSwOutSwCompareMatch       =  15 ,      //ʼͣڽллڱȽƥ
																										     
     PWM_GTIOCx_HighCEndKpCompareMatch       = 	16 ,      //ʼߣѭȽƥ
     PWM_GTIOCx_HighCEndCompareMatch         =  17 ,      //ʼߣѭıȽƥ
     PWM_GTIOCx_HighCEndHighCompareMatch     =   18,       //ʼߣѭ,ڱȽƥ
     PWM_GTIOCx_HighCEndSwCompareMatch       =   19,       //ʼߣѭ,лڱȽƥ
     PWM_GTIOCx_High0OutKpCompareMatch       = 	20 ,      //ʼߣڽ0Ƚƥ
     PWM_GTIOCx_High0OutCompareMatch         =  21 ,      //ʼߣڽ0Ƚƥ
     PWM_GTIOCx_High0OutdHighCompareMatch    =   22,       //ʼߣڽ0ڱȽƥ
     PWM_GTIOCx_High0OutSwCompareMatch       =   23,       //ʼߣڽ0лڱȽƥ
     PWM_GTIOCx_High1OutKpCompareMatch       = 	24 ,      //ʼߣڽ1Ƚƥ
     PWM_GTIOCx_High1OutCompareMatch         =  25 ,      //ʼߣڽ1Ƚƥ
     PWM_GTIOCx_High1OutdHighCompareMatch    =   26,       //ʼߣڽ1ڱȽƥ
     PWM_GTIOCx_High1OutSwCompareMatch       =   27,       //ʼߣڽ1лڱȽƥ
     PWM_GTIOCx_HighSwOutKpCompareMatch      =  28 ,       //ʼߣڽлȽƥ
     PWM_GTIOCx_HighSwOutCompareMatch        =	 29,       //ʼߣڽлȽƥ
     PWM_GTIOCx_HighSwOutdHighCompareMatch   =   30,       //ʼߣڽлڱȽƥ
     PWM_GTIOCx_HighSwOutSwCompareMatch      =   31,       //ʼߣڽллڱȽƥ

}GTIOFunc_FunState;


/**************PWM Channel GTIOCA/B select******************************/ 
#define PWM_GTIOCA        	0  //GTIOCA
#define PWM_GTIOCB        	1  //GTIOCB

typedef enum 
{
	IOLow = 0, 
	IOHigh = !IOLow
}IO_FunState;


/**************PWM Channel GTIOCA/B prohibite use status******************************/ 
typedef enum 
{
	PWM_GTIOCx_ProhibOut   = 0,  //GTIOCx ýֹ
	PWM_GTIOCx_HiZ         = 1,  //GTIOCx ʱΪ
	PWM_GTIOCx_Low         = 2,  //GTIOCx ʱ
	PWM_GTIOCx_High        = 3,  //GTIOCx ʱ
}GPTDis_FunState;

typedef enum 
{
	Freq_Div1 = 0, 						//1Ƶ
	Freq_Div4 = 1, 						//4Ƶ
	Freq_Div16 = 2, 					//16Ƶ
	Freq_Div64 = 3, 					//64Ƶ
}GPTFiltDiv_FunState;


typedef enum 
{
	Int_GtcACmpCap = 0, 						//GTCCRA Ƚƥ/벶ж
	Int_GtcBCmpCap = 1, 						//GTCCRB Ƚƥ/벶ж
	Int_GtcCCmpCap = 2, 						//GTCCRC Ƚƥ/벶ж
	Int_GtcDCmpCap = 3, 						//GTCCRD Ƚƥ/벶ж
	Int_GtcECmpCap = 4, 						//GTCCRE Ƚƥ/벶ж
	Int_GtcFCmpCap = 5, 						//GTCCRF Ƚƥ/벶ж
	Int_GtcRSwtoothOv = 6, 					//ݲ/ǲж
	Int_GtcRSwtoothUn = 7, 					//ݲ/ǲж
	Int_GtcRSwtoothDouble = 8, 			//ݲ/硢ǲ/ж	
	
	Int_Dis_GroupA = 9, 			      //A
	Int_Dis_GroupB = 10, 			      //B
	Int_Dis_GroupC = 11, 			      //C
	Int_Dis_GroupD = 12, 			      //D
	
	Int_Dis_GRPABH = 13, 			      //
	Int_Dis_GRPABL = 14, 			      //
}GPTINT_FunState;

typedef enum 
{
	GPT_BuffNone = 0, 						//BUFFER
	GPT_BuffSingle = 1, 						//BUFFER
  GPT_BuffDouble = 2, 						//˫BUFFER

}GPTBuff_FunState;

typedef enum 
{
	GPT_DisSrc_GroupA = 0, 						//ѡAԴ
  GPT_DisSrc_GroupB = 1, 						//ѡBԴ
	GPT_DisSrc_GroupC = 2, 						//ѡCԴ
	GPT_DisSrc_GroupD = 3, 						//ѡDԴ
}GPTDisSrc_FunState;



typedef struct
{
//	GPTSelect_t  GPT;        			  /*!< select GPT0 or GPT1. */
	
	PWMSrc_TypeDef PwmSrc;   			  /*!< select PWM trigger source. */
	
	PWMSrc_TypeDef PwmStopSrc;   			  /*!< select PWM stop source. */
	
	PWMSrc_TypeDef PwmClrSrc;   			  /*!< select PWM clear source. */
	
	GTIOMod_FunState PwmMod;  			/*!< select PWM output mode. */
	
	GTIODiv_FunState PwmFreqDiv;		/*!< select PWM timer frequency. */
	
	GTIODir_FunState PwmCountDir;		/*!< select PWM timer count direction. */
	
	GTIODir_FunState PwmCountDirF;		/*!< select PWM timer count format force or not. */
	
	GTIOForceDuty_FunState GptAFDuty; 	  /*!< select GTIOCA output Duty. */
	
	GTIOForceDuty_FunState GptBFDuty;     /*!< select GTIOCB output Duty. */
	
	uint8_t GptAFDutyCtrl; 	  /*!< select GTIOCA force output Duty control. */
	
	uint8_t GptBFDutyCtrl; 	  /*!< select GTIOCB force output Duty control. */
	
	uint8_t GptAOutCtrl;             /*!< select GTIOCA output:ENABLE/DISABLE. */
	
	uint8_t GptBOutCtrl;             /*!< select GTIOCB output:ENABLE/DISABLE. */
		
	IO_FunState GptIOADefaultS;       /*!< select GPT IO A default status when start or stop. */
	
	IO_FunState GptIOBDefaultS;       /*!< select GPT IO B default status when start or stop. */
	
	uint8_t PwmAFilt;                /*!< select PWM input filter: ENABLE/DISABLE. */
	
	GPTFiltDiv_FunState GptAFiltDiv;    /*!< select GPT input filter's freqency. */

	uint8_t PwmBFilt;                /*!< select PWM input filter: ENABLE/DISABLE. */
	
	GPTFiltDiv_FunState GptBFiltDiv;    /*!< select GPT input filter's freqency. */
	
	uint32_t Period;                 /*!< set the counter period. */
	
	uint32_t DutyA;                  /*!< set the GPTIOA's duty. */
	
	uint32_t DutyB;                  /*!< set the GPTIOB's duty. */
	
	uint32_t DeadAera;                /*!< set the dead area time. */
	
	GPTBuff_FunState GptPrBuff;      /*!< select GTPR buffer status. */
	
	GPTBuff_FunState GptABuff;      /*!< select GPT GTCCRA buffer status. */
	
	GPTBuff_FunState GptBBuff;      /*!< select GPT GTCCRB buffer status. */
	
	GPTDis_FunState GptDisOutS;      /*!< select GPT disable status output status. */
	
	GTIOFunc_FunState GptIOAFunc;      /*!< select GPT IO A function. */
	
	GTIOFunc_FunState GptIOBFunc;      /*!< select GPT IO B function. */
	
	

	GPTDisSrc_FunState GptDisSrc;    /*!< select GPT disable source. */
	

} GPT_InitTypeDef;



/**
  * @brief  Enable to write WP bit .
  * @param  GPTx: 
	*            GPT00,GPT01,GPT02,GPT03
	*            GPT10 ~ GPT17    
  * @retval None
  */
void PWM_Lock(GPT_Type * GPTx);
void PWM_UnLock(GPT_Type * GPTx);

void PWM_Counter_SoftStart(GPT_Type * GPTx);
void PWM_Start_Source(GPT_Type * GPTx,PWMSrc_TypeDef Src,uint8_t Stat);
void PWM_GTIOCxIO_OutCtrl(GPT_Type * GPTx,uint8_t Chann,FunctionalState IOStat);
void PWM_GTIOCx_Func(GPT_Type * GPTx,uint8_t Chann,GTIOFunc_FunState Func);

void PWM_Counter_SoftStop(GPT_Type * GPTx);
void PWM_Counter_SoftClear(GPT_Type * GPTx);
void PWM_Start_Source(GPT_Type * GPTx,PWMSrc_TypeDef Src,uint8_t Stat);
void PWM_Stop_Source(GPT_Type * GPTx,PWMSrc_TypeDef Src,uint8_t Stat);
void PWM_Clear_Source(GPT_Type * GPTx,PWMSrc_TypeDef Src,uint8_t Stat);
void PWM_UpCount_Source(GPT_Type * GPTx,PWMSrc_TypeDef Src,uint8_t Stat);
void PWM_DownCount_Source(GPT_Type * GPTx,PWMSrc_TypeDef Src,uint8_t Stat);
void PWM_CaptureA_Source(GPT_Type * GPTx,PWMSrc_TypeDef Src,uint8_t Stat);
void PWM_CaptureB_Source(GPT_Type * GPTx,PWMSrc_TypeDef Src,uint8_t Stat);
void PWM_Start(GPT_Type * GPTx);
void PWM_Stop(GPT_Type * GPTx);

void PWM_WaveMode(GPT_Type * GPTx,GTIOMod_FunState WavMod);
void PWM_TimerFrequency(GPT_Type * GPTx,GTIODiv_FunState Freq);
void PWM_TimerDir(GPT_Type * GPTx,GTIODir_FunState CountDir);
void PWM_TimerDir_Control(GPT_Type * GPTx,uint8_t Cstatus);
void PWM_GTIOCA_Duty(GPT_Type * GPTx,GTIOForceDuty_FunState VDuty);
void PWM_GTIOCA_DutyCtrl(GPT_Type * GPTx,uint8_t Cstatus);
void PWM_GTIOCA_Output(GPT_Type * GPTx,uint8_t OutSta);
void PWM_GTIOCB_Duty(GPT_Type * GPTx,uint8_t VDuty);
void PWM_GTIOCB_DutyCtrl(GPT_Type * GPTx,uint8_t Cstatus);
void PWM_GTIOCB_Output(GPT_Type * GPTx,uint8_t OutSta);
void PWM_GTIOCxIO_StopCountStat(GPT_Type * GPTx,uint8_t Chann,IO_FunState IOStat);
void PWM_GTIOCxIO_HoldStat(GPT_Type * GPTx,uint8_t Chann,IO_FunState IOStat);
void PWM_GTIOCxIO_ProhibUseStat(GPT_Type * GPTx,uint8_t Chann,GPTDis_FunState IOStat);
void PWM_GTIOCxIO_InFilter(GPT_Type * GPTx,uint8_t Chann,FunctionalState IOStat);
void PWM_GTIOCxIOIn_FilterFreq(GPT_Type * GPTx,uint8_t Chann,GPTFiltDiv_FunState IOStat);
void PWM_Interrupt_Req(GPT_Type * GPTx,GPTINT_FunState INTType,FunctionalState INTStat);
void PWM_DisRequest_GroupSelect(GPT_Type * GPTx,GPTINT_FunState INTType);
void PWM_DisPriority_Select(GPT_Type * GPTx,GPTINT_FunState INTType);
void PWM_PRBuffer_Select(GPT_Type * GPTx,FunctionalState BufCtrl,GPTBuff_FunState BufType);
void PWM_GTCCRBuffer_Select(GPT_Type * GPTx,FunctionalState BufCtrl,GPTBuff_FunState BufAType,GPTBuff_FunState BufBType);
void PWM_FB_Ctrl(GPT_Type * GPTx,FunctionalState FbStat);
uint32_t PWM_Status(GPT_Type * GPTx);
void GPT_Init(GPT_Type * GPTx,GPT_InitTypeDef *GPT_InitStruct);


#endif 
