/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __TRNG_H_
#define __TRNG_H_

#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "common.h"
#include "cgc.h"

/***********************************************************************************************************************
Typedef definitions
***********************************************************************************************************************/
typedef enum
{
    TRNGCKS_CKS_DIV_1,
    TRNGCKS_CKS_DIV_2,
    TRNGCKS_CKS_DIV_4,
    TRNGCKS_CKS_DIV_8,
    TRNGCKS_CKS_DIV_16,
    TRNGCKS_CKS_DIV_32,
    TRNGCKS_CKS_DIV_64,
    TRNGCKS_CKS_DIV_128
} trng_div_t;

/***********************************************************************************************************************
Global functions
***********************************************************************************************************************/
//=================================================================================================================

void TRNG_Init(trng_div_t div_cnt);
void TRNG_DeInit(void);
uint32_t TRNG_GetRandomNumber(void);

#endif

