#include "aes.h"



/******************************************************************************
* Function Name: AES_Init
* @brief  AES init demo
* @param  
* @return none
*******************************************************************************/
void AES_Init(AES_InitTypeDef* pAESInit)
{
	CGC_PERAPeriphClockCmd(CGC_PERAPeriph_AES,ENABLE);
	
	AES_Start();
//		AES->MREG |= AES_MREG_core_en_Msk;
	
	while(AES_CREGWritable_Status());
	AES->CREG = (pAESInit->encrypt_mode<<AES_CREG_chain_Pos) | (pAESInit->key_length<<AES_CREG_key_len_Pos);//| (pAESInit->run_mode<<AES_CREG_inv_cipher_Pos) 
	
	while(AES_IVWritable_Status());
	AES->IV = pAESInit->pIVdata[0];
	AES->IV = pAESInit->pIVdata[1];
	AES->IV = pAESInit->pIVdata[2];
	AES->IV = pAESInit->pIVdata[3];
	
	while(AES_K0Writable_Status());
	AES->KEY0 = pAESInit->pKeydata[0];
	AES->KEY0 = pAESInit->pKeydata[1];
	AES->KEY0 = pAESInit->pKeydata[2];
	AES->KEY0 = pAESInit->pKeydata[3];
	if(KEY_LENGTH_256==pAESInit->key_length)
	{
		while(AES_K1Writable_Status());
		AES->KEY1 = pAESInit->pKeydata[4];
		AES->KEY1 = pAESInit->pKeydata[5];
		AES->KEY1 = pAESInit->pKeydata[6];
		AES->KEY1 = pAESInit->pKeydata[7];
	}
	
}

/***********************************************************************************************************************
* Function Name: AES_Encrypt
* @brief  This function encrypt data.
* @param  pAESInit - the pointer of the AES_InitTypeDef structure
* @param  pInputdata - the pointer of the input data
* @param  pOutputdata - the pointer of the output data
* @return None
***********************************************************************************************************************/
void AES_Encrypt(AES_InitTypeDef* pAESInit,uint8_t* pInputdata,uint8_t* pOutputdata)
{
	uint32_t* pU32dat;
	
	while(AES_K0Writable_Status());
	AES->KEY0 = pAESInit->pKeydata[0];
	AES->KEY0 = pAESInit->pKeydata[1];
	AES->KEY0 = pAESInit->pKeydata[2];
	AES->KEY0 = pAESInit->pKeydata[3];
	if(KEY_LENGTH_256==pAESInit->key_length)
	{
		while(AES_K1Writable_Status());
		AES->KEY1 = pAESInit->pKeydata[4];
		AES->KEY1 = pAESInit->pKeydata[5];
		AES->KEY1 = pAESInit->pKeydata[6];
		AES->KEY1 = pAESInit->pKeydata[7];
	}
	
	while(AES_CREGWritable_Status());
	AES->CREG &= ~(AES_CREG_inv_cipher_Msk);
	AES->CREG |= (ENCRYPT_MODE<<AES_CREG_inv_cipher_Pos);
	
	if(pAESInit->encrypt_mode > AES_ECB_MODE)
	{
		while(AES_IVWritable_Status());
		AES->IV = pAESInit->pIVdata[0];
		AES->IV = pAESInit->pIVdata[1];
		AES->IV = pAESInit->pIVdata[2];
		AES->IV = pAESInit->pIVdata[3];
	}
	
	pU32dat = (uint32_t*)pInputdata;
	while(AES_DataWritable_Status());
	AES->DWIN = *pU32dat++;
	AES->DWIN = *pU32dat++;
	AES->DWIN = *pU32dat++;
	AES->DWIN = *pU32dat++;
	
	
	pU32dat = (uint32_t*)pOutputdata;
	while(AES_DataReadable_Status());
	*pU32dat++ = AES->DWIN;
	*pU32dat++ = AES->DWIN;
	*pU32dat++ = AES->DWIN;
	*pU32dat++ = AES->DWIN;
	
}

/***********************************************************************************************************************
* Function Name: AES_Decrypt
* @brief  This function decrypt data.
* @param  pAESInit - the pointer of the AES_InitTypeDef structure
* @param  pInputdata - the pointer of the input data
* @param  pOutputdata - the pointer of the output data
* @return None
***********************************************************************************************************************/
void AES_Decrypt(AES_InitTypeDef* pAESInit,uint8_t* pInputdata,uint8_t* pOutputdata)
{
	uint32_t* pU32dat;
	
	while(AES_K0Writable_Status());
	AES->KEY0 = pAESInit->pKeydata[0];
	AES->KEY0 = pAESInit->pKeydata[1];
	AES->KEY0 = pAESInit->pKeydata[2];
	AES->KEY0 = pAESInit->pKeydata[3];
	if(KEY_LENGTH_256==pAESInit->key_length)
	{
		while(AES_K1Writable_Status());
		AES->KEY1 = pAESInit->pKeydata[4];
		AES->KEY1 = pAESInit->pKeydata[5];
		AES->KEY1 = pAESInit->pKeydata[6];
		AES->KEY1 = pAESInit->pKeydata[7];
	}
	
	while(AES_CREGWritable_Status());
	AES->CREG &= ~(AES_CREG_inv_cipher_Msk);
	AES->CREG |= (DECRYPT_MODE<<AES_CREG_inv_cipher_Pos);
	
	if(pAESInit->encrypt_mode > AES_ECB_MODE)
	{
		while(AES_IVWritable_Status());
		AES->IV = pAESInit->pIVdata[0];
		AES->IV = pAESInit->pIVdata[1];
		AES->IV = pAESInit->pIVdata[2];
		AES->IV = pAESInit->pIVdata[3];
	}
	
	pU32dat = (uint32_t*)pInputdata;
	while(AES_DataWritable_Status());
	AES->DWIN = *pU32dat++;
	AES->DWIN = *pU32dat++;
	AES->DWIN = *pU32dat++;
	AES->DWIN = *pU32dat++;
	
	
	pU32dat = (uint32_t*)pOutputdata;
	while(AES_DataReadable_Status());
	*pU32dat++ = AES->DWIN;
	*pU32dat++ = AES->DWIN;
	*pU32dat++ = AES->DWIN;
	*pU32dat++ = AES->DWIN;
	
}

/******************************************************************************
* Function Name: AES_K0Writable_Status
* @brief  Get AES key0 writable status
* @param  
* @return none
*******************************************************************************/
uint8_t AES_K0Writable_Status(void)
{
	return(!(AES->CREG&AES_CREG_k0_wrrdy_Msk));
}

/******************************************************************************
* Function Name: AES_K1Writable_Status
* @brief  Get AES key1 writable status
* @param  
* @return none
*******************************************************************************/
uint8_t AES_K1Writable_Status(void)
{
	return(!(AES->CREG&AES_CREG_k1_wrrdy_Msk));
}


/******************************************************************************
* Function Name: AES_IVWritable_Status
* @brief  Get AES IV writable status
* @param  
* @return none
*******************************************************************************/
uint8_t AES_IVWritable_Status(void)
{
	return(!(AES->CREG&AES_CREG_iv_wrrdy_Msk));
}


/******************************************************************************
* Function Name: AES_CREGWritable_Status
* @brief  Get AES CREG writable status
* @param  
* @return none
*******************************************************************************/
uint8_t AES_CREGWritable_Status(void)
{
	return(!(AES->CREG&AES_CREG_c_wrrdy_Msk));
}


/******************************************************************************
* Function Name: AES_DataWritable_Status
* @brief  Get AES DWIN writable status
* @param  
* @return none
*******************************************************************************/
uint8_t AES_DataWritable_Status(void)
{
	return(!(AES->CREG&AES_CREG_wrrdy_Msk));
}


/******************************************************************************
* Function Name: AES_DataWrite_Status
* @brief  Get AES DWIN writable status
* @param  
* @return none
*******************************************************************************/
uint8_t AES_DataReadable_Status(void)
{
	return(!(AES->CREG&AES_CREG_rdrdy_Msk));
}



/******************************************************************************
* Function Name: AES_Start
* @brief  Start AES module
* @param  
* @return none
*******************************************************************************/
void AES_Start(void)
{
	AES->MREG |= AES_MREG_core_en_Msk;
}

/******************************************************************************
* Function Name: AES_Reset
* @brief  reset AES module
* @param  
* @return none
*******************************************************************************/
void AES_Reset(void)
{
	AES->MREG &= ~AES_MREG_core_en_Msk;
}






