/***********************************************************************************************************************
Includes
***********************************************************************************************************************/

#include "elc.h"
/* Start user code for include. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */


/***********************************************************************************************************************
* Function Name: ELC_Start
* @brief  This function initializes the ELC module.
* @param  event_dst - event destination number to be start (bit n for ELSELRn)
* @param  event_src - event resources number to be start (value of ELSELRn)
* @return None
***********************************************************************************************************************/
void ELC_Start(uint32_t event_dst, uint32_t event_src)
{
    volatile uint32_t  * sfr_addr;
    
		ELC->ELCR = ELC_ELCR_ELCON_Msk;		//ENABLE ELC function
    sfr_addr = &ELC->ELSR00;
										 
    // ELSELRn(n=00~14) = Link Destination Number
    *(sfr_addr + event_dst) = event_src;
}
/***********************************************************************************************************************
* Function Name: ELC_Stop
* @brief  This function stops the ELC event resources.
* @param  event - event resources to be stoped (bit n for ELSELRn)
* @return None
***********************************************************************************************************************/
void ELC_Stop(uint32_t event)
{
    volatile uint32_t   w_count;
    volatile uint32_t  * sfr_addr;

		ELC->ELCR &= ~ELC_ELCR_ELCON_Msk;		//ENABLE ELC function
    sfr_addr = &ELC->ELSR00;
    
    for (w_count = 0U; w_count < ELC_DESTINATION_COUNT; w_count++) 
    {
        if (0x1U == ((event >> w_count) & 0x1U))
        {
            *sfr_addr = _FF_ELC_EVENT_LINK_OFF;
        }
        
        sfr_addr++;
    }
}
