/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : CMS32G439
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "uart_demo.h"
#include "dac_demo.h"
#include "adc_demo.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
extern uint32_t   g_AdcIntTaken;

int main()
{
    uint32_t msCnt, len;    // count value of 1ms
    
    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);

    Uart0_Init(19200);
		
		dac_Init();
		Adc0_Init();
		ADC_Start(ADC0);
	
    while (1)
    {
        while (g_AdcIntTaken < 1);

        g_AdcIntTaken = 0;
				ADC_Start(ADC0);
        printf("ADC = 0x%04X\n",(uint16_t *)ADC0->ADDR1);
    }

}




