#include "rtc_demo.h"
volatile uint32_t g_ItIntTaken;

void Rtc_Init()
{
    RTC_InitTypeDef RTC_InitStructure = {0};
    GPIO_InitTypeDef GPIO_InitStruct = {0};

		GPIO_PinAFConfig(GPIO_PORTE, GPIO_Pin_1, GROUP_AF_RTC1HZ);
    /*RTC1HZ OUTPUT CONFIG*/
    GPIO_InitStruct.GPIO_Pin    = GPIO_Pin_1;
    GPIO_InitStruct.GPIO_Mode   = GPIO_Mode_OUT;
    GPIO_InitStruct.GPIO_Level   = GPIO_Level_LOW;
    GPIO_InitStruct.GPIO_Ctrl  = GPIO_Control_DIG;
    GPIO_Init(GPIO_PORTE, &GPIO_InitStruct);

    RTC_InitStructure.RTC_Clk = RTC_FSUB; //ѡϵͳʱ
    RTC_InitStructure.RTC_Time.RTC_Seconds = 20;
    RTC_InitStructure.RTC_Time.RTC_Minutes = 30;
    RTC_InitStructure.RTC_Time.RTC_Hours = 8;          //83020
    RTC_InitStructure.RTC_Time.RTC_H12   = RTC_H12_AM;
    RTC_InitStructure.RTC_HourFormat = RTC_HourFormat_12;//RTC_HourFormat_24

    RTC_InitStructure.RTC_Date.RTC_Day = 22;// 22
    RTC_InitStructure.RTC_Date.RTC_WeekDay = SUNDAY;//
    RTC_InitStructure.RTC_Date.RTC_Month = 5;   //5
    RTC_InitStructure.RTC_Date.RTC_Year = 22;   //2022
    RTC_InitStructure.RTC_Period = One_Second; //RTC ÿ1s̶ж

    RTC_InitStructure.RTC_Alarm_Onoff = RTC_Alarm_Off;//жϹر
    RTC_InitStructure.RTC_Alarm.Alarm_Minute = 35; //ӷӼ 35
    RTC_InitStructure.RTC_Alarm.Alarm_Hour  = 11;//Сʱ 110x11
    RTC_InitStructure.RTC_Alarm.Alarm_Week  = ALARM_WEEK(SUNDAY) | ALARM_WEEK(SATURDAY); //ڼ
    RTC_InitStructure.RTC_1HZ_Output = ENABLE; //RTC1HZ diable output
    RTC_Init(&RTC_InitStructure);

    ISR_Register(RTC_IRQn, rtc_interrupt);     //RTCжϷ·ע

    //  RTC_Set_AlarmOn();
}

/***********************************************************************************************************************
* Function Name: RTC_Set_Time
* @brief
* @param     hformat :RTC_HourFormat_12/RTC_HourFormat_24
*            hour 0~23
**           min: 0~59
**           sec: 0~59
**           ampm: RTC_H12_AM/ RTC_H12_PM
* @return  None
***********************************************************************************************************************/
void RTC_Set_Time(uint8_t hformat, uint8_t hour, uint8_t min, uint8_t sec, uint8_t ampm)
{
    RTC_TimeTypeDef RTC_TimeTypeInitStructure;

    RTC_TimeTypeInitStructure.RTC_Hours = hour;
    RTC_TimeTypeInitStructure.RTC_Minutes = min;
    RTC_TimeTypeInitStructure.RTC_Seconds = sec;
    RTC_TimeTypeInitStructure.RTC_H12 = ampm;

    RTC_SetHourFormat(hformat);

    RTC_SetTime(&RTC_TimeTypeInitStructure);
}


static void rtc_callback_alarm(void)
{
    /* Start user code. Do not edit comment generated here */
    /* End user code. Do not edit comment generated here */
}

RTC_CounterTypeDef date_time;
static void rtc_callback_constperiod(void)
{
    /* Start user code. Do not edit comment generated here */
    RTC_Get_CounterValue(&date_time);
    printf("20%02x/%02x/%02x %02x:%02x:%02x\n", date_time.date.RTC_Year, date_time.date.RTC_Month, date_time.date.RTC_Day, \
           date_time.time.RTC_Hours, date_time.time.RTC_Minutes, date_time.time.RTC_Seconds);
    /* End user code. Do not edit comment generated here */
}
void rtc_interrupt(void *msg)
{
    if (RTC->RTCC1 & RTC_RTCC1_WAFG_Msk)       //if generate alarm interrupt
    {
        RTC->RTCC1 &= (uint8_t)~0x10;        // clear WAFG
        NVIC_ClearPendingIRQ(RTC_IRQn);                     //clear INTRTC flag
        rtc_callback_alarm();
    }

    if (RTC->RTCC1 & RTC_RTCC1_RIFG_Msk)         //if generate consant period interrupt
    {
        RTC->RTCC1 &= (uint8_t)~0x08; // clear RIFG
        NVIC_ClearPendingIRQ(RTC_IRQn);                     // clear INTRTC flag
        rtc_callback_constperiod();
    }
}




