/***********************************************************************************************************************
* Copyright (C) . All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : main.c
* Version      :
* Device(s)    : BAT32G439
* Tool-Chain   : MDK(armcc)
* Description  : This file is a template.
* Creation Date: 2022/5/30
***********************************************************************************************************************/

/***********************************************************************************************************************
Macro Definitions
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include <stdio.h>
#include "uart_demo.h"
#include "interval_demo.h"
#include "gpio_demo.h"
#include "delay_demo.h"
#include "cgc.h"

#define FIL_ENABLE   

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/

int main()
{
    uint32_t msCnt;     // count value of 1ms
    int i = 0;
    //-----------------------------------------------------------------------
    // Systick setting
    //-----------------------------------------------------------------------
    SystemCoreClockUpdate();
    msCnt = SystemCoreClock / 1000;
    SysTick_Config(msCnt);
		Led_Init();
    Uart0_Init(19200);
	delay_init(SystemCoreClock);

#ifdef FIL_ENABLE
    extern uint32_t   g_ItIntTaken;

    printf("IntervalTimer operates with fIL\n");
    Interval_Init(IT_FIL, 15000);//ʱ
    IT_Start();

		for(i=0; i<8; i++)
		{	
			delayMS(500);
			printf("15bit IntervalTimer interrupt: No.%02d\n", g_ItIntTaken);
		}
		IT_Stop();
    while(1)
    {
				;
    }

#else

    //-----------------------------------------------------------------------
    // 15bits IntervalTimer (Operation Clock: fSUB)
    //-----------------------------------------------------------------------
    printf("IntervalTimer operates with fSUB\n");
    /* SubOSC ON */
	CGC_LSEConfig(OSC_OSCILLATOR,OSC_NORMAL_POWER); //øϵͳʱ

    Interval_Init(IT_FSUB, 0x7ffe);//ʱ
    IT_Start();

    while(1)
    {
		delayMS(500);
        printf("15bit IntervalTimer interrupt: No.%02d\n", g_ItIntTaken);
    }

#endif

}




